#ifndef TYPON_FUNDAMENTAL_SCOPE_HPP_INCLUDED
#define TYPON_FUNDAMENTAL_SCOPE_HPP_INCLUDED

#include <concepts>


namespace typon::fdt
{

  template <std::invocable<> F>
  struct defer
  {
    F _f;

    ~defer()
    {
      _f();
    }
  };

  template <std::invocable<> F>
  defer(F) -> defer<F>;

}


#endif // TYPON_FUNDAMENTAL_SCOPE_HPP_INCLUDED
