#ifndef TYPON_TYPON_HPP_INCLUDED
#define TYPON_TYPON_HPP_INCLUDED

#include <utility>

#include <typon/core/fork.hpp>
#include <typon/core/forked.hpp>
#include <typon/core/future.hpp>
#include <typon/core/join.hpp>
#include <typon/core/promise.hpp>
#include <typon/core/root.hpp>
#include <typon/core/task.hpp>


namespace typon
{

  template <typename Task>
  Fork<typename Task::promise_type::value_type> fork(Task task)
  {
    // Put the task in a local variable to ensure its destructor will
    // be called on co_return instead of only on coroutine destruction.
    Task local_task = std::move(task);
    co_return co_await std::move(local_task);
  }


  template <typename Task>
  Future<typename Task::promise_type::value_type> future(Task task)
  {
    // Put the task in a local variable to ensure its destructor will
    // be called on co_return instead of only on coroutine destruction.
    Task local_task = std::move(task);
    co_return co_await std::move(local_task);
  }

}


#endif // TYPON_TYPON_HPP_INCLUDED
